VERSION 5.00
Begin VB.Form vbdbauto 
   Caption         =   "Visual Basic sample for database ActiveX automation objects"
   ClientHeight    =   6105
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5550
   LinkTopic       =   "Form1"
   ScaleHeight     =   6105
   ScaleWidth      =   5550
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox systemList 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   360
      Width           =   3375
   End
   Begin VB.CommandButton closeBtn 
      Caption         =   "Close"
      Height          =   315
      Left            =   3960
      TabIndex        =   16
      Top             =   5640
      Width           =   1455
   End
   Begin VB.Frame Frame2 
      Caption         =   "Upload to existing AS/400 file "
      Height          =   1935
      Left            =   120
      TabIndex        =   9
      Top             =   3600
      Width           =   5295
      Begin VB.CommandButton upload 
         Caption         =   "Upload"
         Height          =   315
         Left            =   3840
         TabIndex        =   15
         Top             =   1440
         Width           =   1335
      End
      Begin VB.OptionButton replace 
         Caption         =   "Replace AS/400 file"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   1440
         Width           =   3015
      End
      Begin VB.OptionButton append 
         Caption         =   "Append to AS/400 file"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   1140
         Width           =   3015
      End
      Begin VB.TextBox uploadFile 
         Height          =   315
         Left            =   120
         TabIndex        =   12
         Top             =   600
         Width           =   3015
      End
      Begin VB.Label Label4 
         Caption         =   "PC file:"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   360
         Width           =   3255
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Download "
      Height          =   1695
      Left            =   120
      TabIndex        =   4
      Top             =   1680
      Width           =   5295
      Begin VB.CommandButton download 
         Caption         =   "Download"
         Height          =   315
         Left            =   3840
         TabIndex        =   8
         Top             =   1220
         Width           =   1335
      End
      Begin VB.TextBox downloadFile 
         Enabled         =   0   'False
         Height          =   315
         Left            =   400
         TabIndex        =   7
         Top             =   1220
         Width           =   3015
      End
      Begin VB.OptionButton toFile 
         Caption         =   "To file"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   660
         Width           =   2775
      End
      Begin VB.OptionButton toDisplay 
         Caption         =   "To display"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   360
         Width           =   2895
      End
      Begin VB.Label downloadFileLabel 
         Caption         =   "PC file:"
         Enabled         =   0   'False
         Height          =   255
         Left            =   400
         TabIndex        =   10
         Top             =   980
         Width           =   2415
      End
   End
   Begin VB.TextBox dbFile 
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   3375
   End
   Begin VB.Label Label2 
      Caption         =   "AS/400 database file  (e.g. QIWS.QCUSTCDT):"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   840
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "AS/400 system:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3495
   End
End
Attribute VB_Name = "vbdbauto"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'********************************************************************
'
'                          DOWNLOAD
'
'********************************************************************

Private Sub download_Click()
  Dim done As Boolean
  Dim numberOfRows As Long
  Dim totalRows As Long
  Dim totalColumns As Long
  Dim fileAttr As Integer
  Dim fileNumber As Integer

  ' Validate input values

  If (currentSystem = "") Then
    MsgBox "Enter a system name"
    systemList.SetFocus
    Exit Sub
  End If

  If (dbFile.Text = "") Then
    MsgBox "Enter an AS/400 database file name  (syntax:  Library.File)"
    dbFile.SetFocus
    Exit Sub
  End If

  If (toFile.Value = True) And (downloadFile.Text = "") Then
    MsgBox "Enter a PC file name for download"
    downloadFile.SetFocus
    Exit Sub
  End If

  ' Prompt user before replacing an existing file
  If (toFile.Value = True) Then
    On Error Resume Next
    fileAttr = GetAttr(downloadFile.Text)

    If (Err.Number = 0) Then
      If (MsgBox(downloadFile.Text & " already exists." & vbCr & vbCr & _
                 "Do you want to replace it?", vbYesNo) = vbNo) Then
        Exit Sub
      End If
    End If
    On Error GoTo 0
  End If

  ' Change the mouse pointer to an hour glass
  Screen.MousePointer = vbHourglass

  ' Start the database server, if it is not already started
  If (StartServer = False) Then
    Exit Sub
  End If

  ' Submit the SELECT statement, to request data for download
  If (SelectData = False) Then
    Exit Sub
  End If

  ' Retrieve column information
  If (RetrieveColumnInfo(totalColumns) = False) Then
    Exit Sub
  End If

  ' If the user chose to download to display, put column headings in the grid
  If (toDisplay.Value = True) Then
    InitializeGrid totalColumns

  ' If the user chose to download to file, open the PC file
  Else
    ' Open the file for write access
    fileNumber = FreeFile
    Open downloadFile.Text For Output As #fileNumber
  End If

  ' Initialize the total number of rows in the result set
  totalRows = 0

  ' Retrieve the data and save as appropriate
  Do While Not done

    ' Retrieve the data
    If (RetrieveData(numberOfRows, totalRows, done) = False) Then
      Exit Sub
    End If

    ' Save the retrieved data
    If (toDisplay.Value = True) Then
      WriteDataToDisplay numberOfRows, totalColumns
    Else
      WriteDataToFile numberOfRows, totalColumns, fileNumber
    End If

  ' Finished retrieving data
  Loop

  ' If the user chose to download to display, display the data in the grid
  If (toDisplay.Value = True) Then
    If (displayData.DataGrid.Rows > 2) Then
      ' Remove blank entry
      displayData.DataGrid.RemoveItem 1
    End If

   ' Display the data in the grid
   displayData.Show

  ' If the user chose to download to file, close the file
  Else
   ' Close the file
   Close #fileNumber
  End If

  ' Restore the mouse pointer
  Screen.MousePointer = vbDefault

  ' Display completion message
  MsgBox "Successfully downloaded " & totalRows & " rows"
End Sub

'--------------------------------------------------------------------
Function SelectData() As Boolean
  Dim rc As Long

  ' Perform syntax checking on the statement and determine the data
  ' types of the result set
  rc = mySql.cwbdbPrepareDescribe("Stmt01", _
                                  "select * from " & dbFile.Text, sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    SelectData = False
    Exit Function
  End If

  ' Open the database file and initialize the cursor position
  rc = mySql.cwbdbOpen("Stmt01", "Crsr01", cwbRead, sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    SelectData = False
    Exit Function
  End If

  SelectData = True
End Function

'--------------------------------------------------------------------
Function RetrieveColumnInfo(totalColumns As Long) As Boolean
  Dim rc As Long
  Dim currentColumn As Long

  ' Retrieve information about the format of the selected data
  rc = mySql.cwbdbGetResultDataFormat(sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    RetrieveColumnInfo = False
    Exit Function
  End If

  ' Retrieve the total number of columns in the result set
  totalColumns = myFormat.columnCount

  ' Allocate storage for the column attribute information
  ReDim colLength(totalColumns)
  ReDim colName(totalColumns)
  ReDim colType(totalColumns)
  ReDim colPrecision(totalColumns)
  ReDim colScale(totalColumns)
  ReDim colCCSID(totalColumns)

  ' For each column, retrieve the column attributes so we can format
  ' the data correctly
  For currentColumn = 1 To totalColumns

    ' Retrieve the column length
    rc = myFormat.cwbdbGetColumnLength(currentColumn, _
                                       colLength(currentColumn), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      RetrieveColumnInfo = False
      Exit Function
    End If

    ' Retrieve the column name
    rc = myFormat.cwbdbGetColumnName(currentColumn, _
                                     colName(currentColumn), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      RetrieveColumnInfo = False
      Exit Function
    End If

    ' Use the PC column types for comparisons, instead of using the
    ' SQL types
    myFormat.location = cwbdbLocal

    ' Retrieve the column type
    rc = myFormat.cwbdbGetColumnType(currentColumn, _
                                     colType(currentColumn), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      RetrieveColumnInfo = False
      Exit Function
    End If

    ' Reset to retrieving host information, since we will be retrieving
    ' the data in host format and converting it using the Express conversion
    ' automation objects
    myFormat.location = cwbdbSystem

    ' Retrieve the column precision
    rc = myFormat.cwbdbGetColumnPrecision(currentColumn, _
                                          colPrecision(currentColumn), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      RetrieveColumnInfo = False
      Exit Function
    End If

    ' Retrieve the column scale
    rc = myFormat.cwbdbGetColumnScale(currentColumn, _
                                      colScale(currentColumn), sysErr)

    If (rc <> cwbOK) Then
      ShowError ("SQL")
      RetrieveColumnInfo = False
      Exit Function
    End If

    ' Retrieve the column ccsid
    rc = myFormat.cwbdbGetColumnCCSID(currentColumn, _
                                      colCCSID(currentColumn), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      RetrieveColumnInfo = False
      Exit Function
    End If
  Next currentColumn

  RetrieveColumnInfo = True
End Function

'--------------------------------------------------------------------
Sub InitializeGrid(totalColumns As Long)
  Dim currentColumn As Long

  ' Size the grid based on the number of columns of data
  displayData.SizeCells Val(totalColumns)

  ' Put column headings in the first row.
  displayData.DataGrid.Row = 0
  For currentColumn = 1 To totalColumns
    displayData.DataGrid.Col = currentColumn - 1
    displayData.DataGrid.FixedAlignment(currentColumn - 1) = 2
    displayData.DataGrid.Text = colName(currentColumn)
  Next currentColumn
End Sub

'--------------------------------------------------------------------
Function RetrieveData(numberOfRows As Long, totalRows As Long, _
                      done As Boolean) As Boolean
  Dim rc As Long
  Dim numberOfBytes As Long
  Dim dataLen As Long
  Dim indicatorCount As Long
  Dim errClass As Integer
  Dim errCode As Long
  Dim msgID As String
  Dim msg1 As String
  Dim msg2 As String
  Dim msg3 As String

  ' Request the SELECTed data to be retrieved from the AS/400
  rc = mySql.cwbdbFetch("Crsr01", sysErr)

  If (rc <> cwbOK) Then
    ' Retrieve the host error information
    mySql.cwbdbGetHostErrInfo errClass, errCode, msgID, msg1, msg2, sysErr

    ' If we received the end of the data
    If (errClass = 2) And (errCode = 701) Then
      ' Signal the end of data has been reached.  We will continue, since
      ' some data was returned.
      done = True
      RetrieveData = True

    ' If there is no more data
    ElseIf (errClass = 1) And (errCode = 100) Then
      ' Signal the end of data has been reached
      done = True
      RetrieveData = True

      ' Exit the function since there is no data to process
      Exit Function

    ' If an error occurred, display the error information
    Else
      ShowError ("SQL")

      ' Signal we should stop attempting to retrieve data
      done = True
      RetrieveData = False
      Exit Function
    End If
  End If

  ' Retrieve the number of bytes of data returned
  numberOfBytes = Val(mySql.resultDataLength)

  ' Retrieve the number of rows returned
  numberOfRows = Val(numberOfBytes / myFormat.rowSize)

  ' Allocate storage to hold the data
  ReDim dataBuf(numberOfBytes)

  ' Retrieve the number of indicators returned
  indicatorCount = Val(mySql.resultIndicatorCount)

  ' Allocate storage to hold the indicators
  ReDim indicatorBuf(indicatorCount)

  ' Update the number of rows processed so far
  totalRows = totalRows + numberOfRows

  ' Store the result set in a data buffer
  rc = mySql.cwbdbGetResultData(dataBuf(), dataLen, indicatorBuf(), _
                                indicatorCount, sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    done = True
    RetrieveData = False
  End If

  RetrieveData = True
End Function

'--------------------------------------------------------------------
Function WriteDataToDisplay(numberOfRows As Long, totalColumns As Long) _
                            As Boolean
  Dim rowString As String
  Dim currentRow As Long
  Dim currentColumn As Long
  Dim strNumber As String
  Dim resultSet As New cwbx.Structure
  Dim rowData As New cwbx.Structure
  Dim currentEntry As cwbx.StructureField
  Dim stringCvtr As New cwbx.StringConverter
  Dim longCvtr As New cwbx.LongConverter
  Dim shortCvtr As New cwbx.ShortConverter
  Dim packedCvtr As New cwbx.PackedConverter
  Dim zonedCvtr As New cwbx.ZonedConverter
  Dim bytearry(10) As Byte
  

  ' Set the return data into a structure object so we can extract individual
  ' rows from the result set
  resultSet.Bytes = dataBuf

  ' Build a template which maps the size of each field in a row of the
  ' result set
  For currentColumn = 1 To totalColumns
    rowData.Fields.append "", colLength(currentColumn)
  Next currentColumn

  ' Loop through each row in the result set
  For currentRow = 1 To numberOfRows
    ' Obtain access to a row in the result set
    Set currentEntry = resultSet.Fields.append("", rowData.Length)

    ' Set the row data into the row template structure, so we can access
    ' individual fields within the row
    rowData.Bytes = currentEntry.Value
    
   rowString = ""
   
    ' Loop through each field in the row
    For currentColumn = 1 To totalColumns
      ' Check to see if the field value is null
      If (indicatorBuf(((currentRow - 1) * totalColumns) + (currentColumn - 1)) = -1) Then
        rowString = rowString + "-" + vbTab

'
'     STRING
'
      ' Process string value
      ElseIf (colType(currentColumn) = cwbdbPCString) Then
        ' Use a StringConverter object to convert the field value from a byte
        ' array to a PC string
        stringCvtr.CodePage = colCCSID(currentColumn)
        rowString = rowString & _
                    stringCvtr.FromBytes(rowData(currentColumn).Value) & vbTab

'
'      ZONED
'

      ' Process zoned decimal value
      ElseIf (colType(currentColumn) = cwbdbPCZoned) Then
        ' Right align the value in the grid
        displayData.DataGrid.ColAlignment(currentColumn - 1) = 1

        ' Since we are reusing the ZonedConverter object in a loop, we
        ' will set the decimal position to 0, to avoid an invalid combination
        ' of decimal position and digit values
        zonedCvtr.DecimalPosition = 0

        ' Set the Digits and DecimalPosition properties of the ZonedConverter
        ' object
        zonedCvtr.Digits = colPrecision(currentColumn)
        zonedCvtr.DecimalPosition = colScale(currentColumn)

        ' Use the ZonedConverter object to convert the field value from a
        ' byte array to a PC String
'        tmpString = rowString & _
'                    zonedCvtr.FromBytes(rowData(currentColumn).Value) & vbTab
        rowString = rowString & _
                    zonedCvtr.FromBytes(rowData(currentColumn).Value) & vbTab

'
'     PACKED
'

      ' Process packed decimal value
      ElseIf (colType(currentColumn) = cwbdbPCPacked) Then
        ' Right align the value in the grid
        displayData.DataGrid.ColAlignment(currentColumn - 1) = 1

        ' Since we are reusing the PackedConverter object in a loop, we
        ' will set the decimal position to 0, to avoid an invalid combination
        ' of decimal position and digit values
        packedCvtr.DecimalPosition = 0

        ' Set the Digits and DecimalPosition properties of the PackedConverter
        ' object
        packedCvtr.Digits = colPrecision(currentColumn)
        packedCvtr.DecimalPosition = colScale(currentColumn)

        ' Use the PackedConverter object to convert the field value from a
        ' byte array to a PC String
        rowString = rowString & packedCvtr.FromBytes(rowData(currentColumn).Value) & vbTab
      
'      temp = packedCvtr.FromBytes(rowData(1).Value)
'      rowString = rowString & temp & vbTab

'
'     SHORT
'

      ' Process short integer value
      ElseIf (colType(currentColumn) = cwbdbPCShort) Then
        ' Use a ShortConverter object to convert the field value from a
        ' byte array to a PC short integer.  Then, convert the numeric to
        ' a string
        strNumber = Str(shortCvtr.FromBytes(rowData(currentColumn).Value))

        ' If the field has a nonzero decimal position, insert the decimal
        ' point into the numeric string
        If (colScale(currentColumn) <> 0) Then
          decposition = colScale(currentColumn)
          numberlength = Len(strNumber)

          ' Check to see if we need to insert leading zeros
          If (decposition > (numberlength - 1)) Then
            strNumber = Left(strNumber, 1) + "." + _
                          String(decposition - numberlength + 1, "0") + _
                          Right(strNumber, numberlength - 1)
          Else
            strNumber = _
              Left(strNumber, numberlength - colScale(currentColumn)) _
              & "." & Right(strNumber, colScale(currentColumn))
          End If
        End If

        rowString = rowString & strNumber & vbTab

'
'     LONG
'

      ' Process long integer value
      ElseIf (colType(currentColumn) = cwbdbPCLong) Then
        ' Use a LongConverter object to convert the field value from a
        ' byte array to a PC long integer.  Then, convert the numeric to
        ' a string
        strNumber = Str(longCvtr.FromBytes(rowData(currentColumn).Value))

        ' If the field has a nonzero decimal position, insert the decimal
        ' point into the numeric string
        If (colScale(currentColumn) <> 0) Then
          decposition = colScale(currentColumn)
          numberlength = Len(strNumber)

          ' Check to see if we need to insert leading zeros
          If (decposition > (numberlength - 1)) Then
            strNumber = Left(strNumber, 1) + "." + _
                          String(decposition - numberlength + 1, "0") + _
                          Right(strNumber, numberlength - 1)
          Else
            strNumber = _
              Left(strNumber, numberlength - colScale(currentColumn)) _
              & "." & Right(strNumber, colScale(currentColumn))
          End If
        End If

        rowString = rowString & strNumber & vbTab

'
'     NOT IMPLEMENTED
'
      ' All other data types are not implemented by this sample.
      Else
        rowString = rowString & "Type not implemented by sample " & vbTab
      End If

    ' Advance to next column
    Next currentColumn

    ' Add the row of data to the grid
    displayData.DataGrid.AddItem rowString

    ' Clear the row string
    rowString = ""

  ' Advance to next row
  Next currentRow

  WriteDataToDisplay = True
End Function

'--------------------------------------------------------------------
Function WriteDataToFile(numberOfRows As Long, totalColumns As Long, _
                         fileNumber As Integer) As Boolean
  Dim rowString As String
  Dim currentRow As Long
  Dim currentColumn As Long
  Dim fieldString As String
  Dim resultSet As New cwbx.Structure
  Dim rowData As New cwbx.Structure
  Dim currentEntry As cwbx.StructureField
  Dim stringCvtr As New cwbx.StringConverter
  Dim longCvtr As New cwbx.LongConverter
  Dim shortCvtr As New cwbx.ShortConverter
  Dim packedCvtr As New cwbx.PackedConverter
  Dim zonedCvtr As New cwbx.ZonedConverter

  ' Set the return data into a structure object so we can extract individual
  ' rows from the result set
  resultSet.Bytes = dataBuf

  ' Build a template which maps the size of each field in a row of the
  ' result set
  For currentColumn = 1 To totalColumns
    rowData.Fields.append "", colLength(currentColumn)
  Next currentColumn

  ' Loop through each row in the result set
  For currentRow = 1 To numberOfRows
    ' Obtain access to a row in the result set
    Set currentEntry = resultSet.Fields.append("", rowData.Length)

    ' Set the row data into the row template structure, so we can access
    ' individual fields within the row
    rowData.Bytes = currentEntry.Value

    ' Loop through each field in the row
    For currentColumn = 1 To totalColumns

'
'     STRING
'
      ' Process string value
      If (colType(currentColumn) = cwbdbPCString) Then
        ' Check to see if the field value is null
        If (indicatorBuf(((currentRow - 1) * totalColumns) + _
                                             (currentColumn - 1)) = -1) Then
          fieldString = "-"
        Else
          ' Use a StringConverter object to convert the field value from a byte
          ' array to a PC string
          stringCvtr.CodePage = colCCSID(currentColumn)
          fieldString = stringCvtr.FromBytes(rowData(currentColumn).Value)
        End If

        ' String fields are stored in the file using the column length and
        ' padding with a blank space
        rowString = rowString + fieldString + _
                    String(colLength(currentColumn) + 1 - Len(fieldString), " ")

'
'      ZONED
'

      ' Process zoned decimal value
      ElseIf (colType(currentColumn) = cwbdbPCZoned) Then
        ' Check to see if the field value is null
        If (indicatorBuf(((currentRow - 1) * totalColumns) + _
                                             (currentColumn - 1)) = -1) Then
          fieldString = "-"
        Else
          ' Since we are reusing the ZonedConverter object in a loop, we
          ' will set the decimal position to 0, to avoid an invalid combination
          ' of decimal position and digit values
          zonedCvtr.DecimalPosition = 0

          ' Set the Digits and DecimalPosition properties of the ZonedConverter
          ' object
          zonedCvtr.Digits = colPrecision(currentColumn)
          zonedCvtr.DecimalPosition = colScale(currentColumn)

          ' Use the ZonedConverter object to convert the field value from a
          ' byte array to a PC String
          fieldString = zonedCvtr.FromBytes(rowData(currentColumn).Value)
        End If

        ' Zoned decimal fields are stored in the file using the column
        ' precision and adding space for a possible sign indicator,
        ' leading zero, decimal point, and blank pad
        rowString = rowString + fieldString + _
                    String(colPrecision(currentColumn) + _
                           ZONED_PAD - Len(fieldString), " ")

'
'     PACKED
'

      ' Process packed decimal value
      ElseIf (colType(currentColumn) = cwbdbPCPacked) Then
        ' Check to see if the field value is null
        If (indicatorBuf(((currentRow - 1) * totalColumns) + _
                                             (currentColumn - 1)) = -1) Then
          fieldString = "-"
        Else
          ' Since we are reusing the PackedConverter object in a loop, we
          ' will set the decimal position to 0, to avoid an invalid combination
          ' of decimal position and digit values
          packedCvtr.DecimalPosition = 0

          ' Set the Digits and DecimalPosition properties of the PackedConverter
          ' object
          packedCvtr.Digits = colPrecision(currentColumn)
          packedCvtr.DecimalPosition = colScale(currentColumn)

          ' Use the PackedConverter object to convert the field value from a
          ' byte array to a PC String
          fieldString = packedCvtr.FromBytes(rowData(currentColumn).Value)
        End If

        ' Packed decimal fields are stored in the file using the column
        ' precision and adding space for a possible sign indicator,
        ' leading zero, decimal point, and blank pad
        rowString = rowString + fieldString + _
                    String(colPrecision(currentColumn) + _
                           PACKED_PAD - Len(fieldString), " ")

'
'     SHORT
'

      ' Process short integer value
      ElseIf (colType(currentColumn) = cwbdbPCShort) Then
        ' Check to see if the field value is null
        If (indicatorBuf(((currentRow - 1) * totalColumns) + _
                                             (currentColumn - 1)) = -1) Then
          fieldString = "-"
        Else
          ' Use a ShortConverter object to convert the field value from a
          ' byte array to a PC short integer.  Then, convert the numeric to
          ' a string
          fieldString = Str(shortCvtr.FromBytes(rowData(currentColumn).Value))

          ' If the field has a nonzero decimal position, insert the decimal
          ' point into the numeric string
          If (colScale(currentColumn) <> 0) Then
            decposition = colScale(currentColumn)
            numberlength = Len(fieldString)

            ' Check to see if we need to insert leading zeros
            If (decposition > (numberlength - 1)) Then
              fieldString = Left(fieldString, 1) + "." + _
                            String(decposition - numberlength + 1, "0") + _
                            Right(fieldString, numberlength - 1)
            Else
              fieldString = _
                Left(fieldString, numberlength - colScale(currentColumn)) _
                & "." & Right(fieldString, colScale(currentColumn))
            End If
          End If
        End If

        ' Short integer values are stored in the file using a ten character
        ' field, since this should be enough space to store any short
        ' integer value
        rowString = rowString & fieldString + _
                    String(SHORT_WIDTH - Len(fieldString), " ")

'
'     LONG
'

      ' Process long integer value
      ElseIf (colType(currentColumn) = cwbdbPCLong) Then
        ' Check to see if the field value is null
        If (indicatorBuf(((currentRow - 1) * totalColumns) + _
                                             (currentColumn - 1)) = -1) Then
          fieldString = "-"
        Else
          ' Use a LongConverter object to convert the field value from a
          ' byte array to a PC long integer.  Then, convert the numeric to
          ' a string
          fieldString = Str(longCvtr.FromBytes(rowData(currentColumn).Value))

          ' If the field has a nonzero decimal position, insert the decimal
          ' point into the numeric string
          If (colScale(currentColumn) <> 0) Then
            decposition = colScale(currentColumn)
            numberlength = Len(fieldString)

            ' Check to see if we need to insert leading zeros
            If (decposition > (numberlength - 1)) Then
              fieldString = Left(fieldString, 1) + "." + _
                            String(decposition - numberlength + 1, "0") + _
                            Right(fieldString, numberlength - 1)
            Else
              fieldString = _
                Left(fieldString, numberlength - colScale(currentColumn)) _
                & "." & Right(fieldString, colScale(currentColumn))
            End If
          End If
        End If

        ' Long integer values are stored in the file using a fifteen character
        ' field, since this should be enough space to store any long
        ' integer value
        rowString = rowString & fieldString + _
                    String(LONG_WIDTH - Len(fieldString), " ")

'
'     NOT IMPLEMENTED
'

      ' All other data types are not implemented by this sample.
      Else
        rowString = rowString & "Type not implemented by sample "
      End If

    ' Advance to next column
    Next currentColumn

    ' Add the row of data to the file
    Print #fileNumber, rowString

    ' Clear the row string
    rowString = ""

  ' Advance to next row
  Next currentRow

  WriteDataToFile = True
End Function


'********************************************************************
'
'                          UPLOAD
'
'********************************************************************

Private Sub upload_Click()
  Dim dbLibName As String
  Dim dbFileName As String
  Dim dbMbrName As String
  Dim rc As Long
  Dim numberOfFields As Long
  Dim fileAttr As Integer

  ' Validate input values

  If (currentSystem = "") Then
    MsgBox "Enter a system name"
    systemList.SetFocus
    Exit Sub
  End If

  If (dbFile.Text = "") Then
    MsgBox "Enter an AS/400 database file name  (syntax:  Library.File)"
    dbFile.SetFocus
    Exit Sub
  End If

  If (ParseDBFileName(dbLibName, dbFileName) = False) Then
    MsgBox "Invalid AS/400 database file name  (syntax:  Library.File)"
    dbFile.SetFocus
    Exit Sub
  End If

  If (uploadFile.Text = "") Then
    MsgBox "Enter a PC file name for upload"
    uploadFile.SetFocus
    Exit Sub
  End If

  On Error Resume Next
  fileAttr = GetAttr(uploadFile.Text)

  If (Err.Number <> 0) Or (fileAttr And vbDirectory) Then
    MsgBox (uploadFile.Text & " does not exist.")
    uploadFile.SetFocus
    Exit Sub
  End If
  On Error GoTo 0

  ' Change the mouse pointer to an hour glass
  Screen.MousePointer = vbHourglass

  ' Start the database server, if it is not already started
  If (StartServer = False) Then
    Exit Sub
  End If

  ' If the replace option was chosen, clear the database file member
  If (replace.Value = True) Then
    ' Retrieve the name of the first member in the file
    If (RetrieveMbrName(dbLibName, dbFileName, dbMbrName) = False) Then
      Exit Sub
    End If

    rc = myDB2.cwbdbClearMember(dbLibName, dbFileName, dbMbrName, sysErr)
    If (rc <> cwbOK) Then
      ShowError ("DB2")
      Exit Sub
    End If
  End If

  ' Retrieve the number of fields in the file
  If (RetrieveFieldCount(dbLibName, dbFileName, numberOfFields) = False) Then
    Exit Sub
  End If

  ' Build the insert statement with parameter markers
  If (BuildInsertStmt(dbLibName, dbFileName, numberOfFields) = False) Then
    Exit Sub
  End If

  ' Write the data to the AS/400 database file
  If (SendData(numberOfFields) = False) Then
    Exit Sub
  End If

  ' Restore the mouse pointer
  Screen.MousePointer = vbDefault

  ' Display the completion message
  MsgBox "Upload completed successfully"

End Sub

'--------------------------------------------------------------------
Private Function ParseDBFileName(dbLibName As String, dbFileName As String) _
                                                         As Boolean
  Dim filePosition As Long

  filePosition = InStr(1, dbFile.Text, ".")

  ' If the file separator was not found
  If (filePosition = 0) Then
    ParseDBFileName = False
    Exit Function

  ' Separate the file name into its library and file name components
  Else
    dbLibName = UCase(Mid(dbFile.Text, 1, filePosition - 1))
    dbFileName = UCase(Mid(dbFile.Text, filePosition + 1))
  End If

  ParseDBFileName = True
End Function

'--------------------------------------------------------------------
Function RetrieveMbrName(dbLibName As String, dbFileName As String, _
                         dbMbrName As String) As Boolean
  Dim rc As Long
  Dim firstColumnLength As Long
  Dim indicatorCount As Long
  Dim dataLen As Long
  Dim stringCvtr As New cwbx.StringConverter

  ' Retrieve the member names in the database file
  rc = myCatalog.cwbdbRetrieveMemberInfo(dbLibName, dbFileName, "*", _
                                         cwbdbGetMbrName, sysErr)
  If (rc <> cwbOK) Then
    ShowError ("Catalog")
    RetrieveMbrName = False
    Exit Function
  End If

  ' Retrieve information about the format of the returned data
  rc = myCatalog.cwbdbGetResultDataFormat(sysErr)
  If (rc <> cwbOK) Then
    ShowError ("Catalog")
    RetrieveMbrName = False
    Exit Function
  End If

  ' Retrieve the length of the first column
  rc = myFormat.cwbdbGetColumnLength(1, firstColumnLength, sysErr)
  If (rc <> cwbOK) Then
    showCwbError
    RetrieveMbrName = False
    Exit Function
  End If

  ' Allocate storage to hold the member names
  ReDim dataBuf(myCatalog.resultDataLength)

  ' Store the member names in a data buffer
  rc = myCatalog.cwbdbGetResultData(dataBuf(), dataLen, Empty, _
                                    indicatorCount, sysErr)
  If (rc <> cwbOK) Then
    ShowError ("Catalog")
    RetrieveMbrName = False
    Exit Function
  End If

  ' Extract the first member name
  stringCvtr.Length = firstColumnLength
  dbMbrName = stringCvtr.FromBytes(dataBuf)

  ' Signal success
  RetrieveMbrName = True
End Function

'--------------------------------------------------------------------
Function RetrieveFieldCount(dbLibName As String, dbFileName As String, _
                            numberOfFields As Long) As Boolean
  Dim rc As Long
  Dim numberOfBytes As Long

  ' Retrieve the field names in the database file
  rc = myCatalog.cwbdbRetrieveFieldInfo(dbLibName, dbFileName, "*", _
                                        cwbdbGetFldName, sysErr)
  If (rc <> cwbOK) Then
    ShowError ("Catalog")
    RetrieveFieldCount = False
    Exit Function
  End If

  ' Retrieve information about the format of the returned data
  rc = myCatalog.cwbdbGetResultDataFormat(sysErr)
  If (rc <> cwbOK) Then
    ShowError ("Catalog")
    RetrieveFieldCount = False
    Exit Function
  End If

  ' Retrieve the number of bytes in the result set
  numberOfBytes = Val(myCatalog.resultDataLength)

  ' There will be one row in the result set for each field in the
  ' database file.  Therefore, we can divide the number of bytes
  ' in the result set by the size of one row, to determine the
  ' number of fields in the database file.
  numberOfFields = Val(numberOfBytes / myFormat.rowSize)

  ' Signal success
  RetrieveFieldCount = True
End Function

'--------------------------------------------------------------------
Function BuildInsertStmt(dbLibName As String, dbFileName As String, _
                         numberOfFields As Long) As Boolean
  Dim rc As Long
  Dim valuesStr As String
  Dim currentField As Long

  ' Initialize the values string
  valuesStr = " VALUES("

  ' Add a "?" to the values string for each field in the database file
  For currentField = 1 To numberOfFields
    valuesStr = valuesStr & "?"
    If currentField < numberOfFields Then
      valuesStr = valuesStr & ","
    End If
  Next currentField

  ' Terminate the values string
  valuesStr = valuesStr & ")"

  ' Perform syntax checking on the insert statement
  rc = mySql.cwbdbPrepare( _
         "Insrt01", _
         "INSERT INTO " & dbLibName & "." & dbFileName & " ? ROWS" & valuesStr, _
         sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    BuildInsertStmt = False
    Exit Function
  End If

  ' Specify which object should be used for storing the data types of the
  ' parameter markers
  rc = mySql.cwbdbSetParmMarkerFormat(myParamFmt, sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    BuildInsertStmt = False
    Exit Function
  End If

  ' Determine the data types for the parameter markers
  rc = mySql.cwbdbDescribeParameterMarkers("Insrt01", sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    BuildInsertStmt = False
    Exit Function
  End If

  ' Retrieve the data types of the parameter markers
  rc = mySql.cwbdbGetResultParmMarkerFormat(sysErr)
  If (rc <> cwbOK) Then
    ShowError ("SQL")
    BuildInsertStmt = False
    Exit Function
  End If

  ' Retrieve the total number of columns in the result set
  totalParams = myParamFmt.parameterCount

  ' Allocate storage for the column attribute information
  ReDim colLength(totalParams)
  ReDim colType(totalParams)
  ReDim colPrecision(totalParams)
  ReDim colScale(totalParams)
  ReDim colCCSID(totalParams)

  ' For each column, retrieve the column attributes so we can format
  ' the data correctly
  For currentParam = 1 To totalParams

    ' Retrieve the column length
    rc = myParamFmt.cwbdbGetParameterLength(currentParam, _
                                       colLength(currentParam), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      BuildInsertStmt = False
      Exit Function
    End If

    ' Use the PC column types for comparisons, instead of using the
    ' SQL types
    myParamFmt.location = cwbdbLocal

    ' Retrieve the column type
    rc = myParamFmt.cwbdbGetParameterType(currentParam, _
                                     colType(currentParam), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      BuildInsertStmt = False
      Exit Function
    End If

    ' Reset to retrieving host information, since we will be using the Express
    ' conversion automation objects to convert the insert data from PC
    ' to AS/400 format
    myParamFmt.location = cwbdbSystem

    ' Retrieve the column precision
    rc = myParamFmt.cwbdbGetParameterPrecision(currentParam, _
                                          colPrecision(currentParam), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      BuildInsertStmt = False
      Exit Function
    End If

    ' Retrieve the column scale
    rc = myParamFmt.cwbdbGetParameterScale(currentParam, _
                                      colScale(currentParam), sysErr)

    If (rc <> cwbOK) Then
      ShowError ("SQL")
      BuildInsertStmt = False
      Exit Function
    End If

    ' Retrieve the column CCSID
    rc = myParamFmt.cwbdbGetParameterCCSID(currentParam, _
                                      colCCSID(currentParam), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      BuildInsertStmt = False
      Exit Function
    End If
  Next currentParam

  ' Signal success
  BuildInsertStmt = True
End Function

'--------------------------------------------------------------------
Function SendData(numberOfFields As Long) As Boolean
  Dim rc As Long
  Dim record As String
  Dim fileNumber As Integer
  Dim recordData As New cwbx.Structure
  Dim currentColumn As Long
  Dim currentField As String
  Dim stringCvtr As New cwbx.StringConverter
  Dim zonedCvtr As New cwbx.ZonedConverter
  Dim packedCvtr As New cwbx.PackedConverter
  Dim shortCvtr As New cwbx.ShortConverter
  Dim longCvtr As New cwbx.LongConverter
  Dim blockSize As Long
  Dim rowsToSend As Long

  ' Specify the number of rows to send at one time
  blockSize = 50

  ' For each row in the block to send, build a template which maps the
  ' size of each field in the row of the insert data.
  For rowsToSend = 1 To blockSize
    For currentColumn = 1 To numberOfFields
      recordData.Fields.append "", colLength(currentColumn)
    Next currentColumn
  Next rowsToSend

  ' Allocate storage to store the record and the indicators
  ReDim dataBuf(recordData.Length)
  ReDim indicatorBuf(numberOfFields * blockSize)

  ' Open the PC file, containing the data, for read access
  fileNumber = FreeFile
  Open uploadFile For Input As #fileNumber

  ' Loop until the end of file is reached
  Do While Not EOF(fileNumber)
    rowsToSend = 0

    Do While (rowsToSend < blockSize) And (Not EOF(fileNumber))
      ' Read a record from the file
      Input #fileNumber, record
      
      ' Increment the number of rows in the block to send
      rowsToSend = rowsToSend + 1

      ' Process each field in the row
      For currentColumn = 1 To numberOfFields

'
'     STRING
'

        ' Process string value
        If colType(currentColumn) = cwbdbPCString Then

          ' Extract the string value from the record and trim the blank pad
          fieldWidth = colLength(currentColumn) + 1
          currentField = Left(record, fieldWidth - 1)

          ' If the value is NULL, set the NULL indicator.  Note: This
          ' implementation prohibits you from having a string value of
          ' "-" in your database
          If (Trim(currentField) = "-") Then
            indicatorBuf( _
              ((rowsToSend - 1) * numberOfFields) + currentColumn) = -1
          Else
            ' Retrieve the CCSID for this column
            stringCvtr.CodePage = colCCSID(currentColumn)

            ' Convert the string value to the column CCSID and store the
            ' value in the insert buffer as a byte array.  The recordData
            ' Structure object is used to insert the bytes into the proper
            ' position within the insert buffer.
            recordData(((rowsToSend - 1) * numberOfFields) + currentColumn) = _
              stringCvtr.ToBytes(currentField)
          End If

'
'     ZONED
'

        ' Process zoned decimal value
        ElseIf colType(currentColumn) = cwbdbPCZoned Then
          ' Extract the zoned decimal value from the record and trim any blank
          ' pad characters
          fieldWidth = colPrecision(currentColumn) + ZONED_PAD
          currentField = Left(record, fieldWidth)
          currentField = Trim(currentField)

          ' If the value is NULL, set the NULL indicator.
          If (currentField = "-") Then
            indicatorBuf( _
              ((rowsToSend - 1) * numberOfFields) + currentColumn) = -1
          Else
            ' Since we are reusing the ZonedConverter object in a loop, we
            ' will set the decimal position to 0, to avoid an invalid combination
            ' of decimal position and digit values
            zonedCvtr.DecimalPosition = 0

            ' Use the column precision and scale values to set the Digits and
            ' DecimalPosition properties
            zonedCvtr.Digits = colPrecision(currentColumn)
            zonedCvtr.DecimalPosition = colScale(currentColumn)

            ' Use the ZonedConverter object to convert the value from a PC
            ' string to a zoned decimal value in a byte array.  Use the
            ' Structure object to to store the bytes in the correct position
            ' within the insert buffer
            recordData(((rowsToSend - 1) * numberOfFields) + currentColumn) = _
              zonedCvtr.ToBytes(currentField)
          End If

'
'     PACKED
'

        ' Process packed decimal value
        ElseIf colType(currentColumn) = cwbdbPCPacked Then
          ' Extract the packed decimal value from the record and trim any blank
          ' pad characters
          fieldWidth = colPrecision(currentColumn) + PACKED_PAD
          currentField = Left(record, fieldWidth)
          currentField = Trim(currentField)

          ' If the value is NULL, set the NULL indicator.
          If (currentField = "-") Then
            indicatorBuf( _
              ((rowsToSend - 1) * numberOfFields) + currentColumn) = -1
          Else
            ' Since we are reusing the PackedConverter object in a loop, we
            ' will set the decimal position to 0, to avoid an invalid combination
            ' of decimal position and digit values
            packedCvtr.DecimalPosition = 0

            ' Use the column precision and scale values to set the Digits and
            ' DecimalPosition properties
            packedCvtr.Digits = colPrecision(currentColumn)
            packedCvtr.DecimalPosition = colScale(currentColumn)

            ' Use the PackedConverter object to convert the value from a PC
            ' string to a packed decimal value in a byte array.  Use the
            ' Structure object to to store the bytes in the correct position
            ' within the insert buffer
            recordData(((rowsToSend - 1) * numberOfFields) + currentColumn) = _
              packedCvtr.ToBytes(currentField)
          End If

'
'     SHORT
'

        ' Process short integer value
        ElseIf colType(currentColumn) = cwbdbPCShort Then
          ' Extract the short integer value from the record and trim any blank
          ' pad characters
          fieldWidth = SHORT_WIDTH
          currentField = Left(record, fieldWidth)
          currentField = Trim(currentField)

          ' If the value is NULL, set the NULL indicator.
          If (currentField = "-") Then
            indicatorBuf( _
              ((rowsToSend - 1) * numberOfFields) + currentColumn) = -1
          Else
            ' Use the ShortConverter object to convert the value from a PC
            ' short integer to an AS/400 format short integer value in a byte
            ' array.  Use the Structure object to to store the bytes in the
            ' correct position within the insert buffer
            recordData(((rowsToSend - 1) * numberOfFields) + currentColumn) = _
              shortCvtr.ToBytes(currentField)
          End If

'
'     LONG
'

        ' Process long integer value
        ElseIf colType(currentColumn) = cwbdbPCLong Then
          ' Extract the long integer value from the record and trim any blank
          ' pad characters
          fieldWidth = LONG_WIDTH
          currentField = Left(record, fieldWidth)
          currentField = Trim(currentField)

          ' If the value is NULL, set the NULL indicator.
          If (currentField = "-") Then
            indicatorBuf( _
              ((rowsToSend - 1) * numberOfFields) + currentColumn) = -1
          Else
            ' Use the LongConverter object to convert the value from a PC
            ' long integer to an AS/400 format long integer value in a byte
            ' array.  Use the Structure object to to store the bytes in the
            ' correct position within the insert buffer
            recordData(((rowsToSend - 1) * numberOfFields) + currentColumn) = _
              longCvtr.ToBytes(currentField)
          End If

'
'     NOT IMPLEMENTED
'

        ' If we encounter a type which is not implemented by this sample,
        ' we will cancel the upload request
        Else
          MsgBox "Field type not implemented by sample"
          Close #fileNumber
          Screen.MousePointer = vbDefault
          SendData = False
          Exit Function
        End If

        ' Update the record string to begin at the next field
        If currentColumn <> numberOfFields Then
          record = Right(record, Len(record) - fieldWidth)
        End If

      Next currentColumn

    ' Block size reached or end of file found
    Loop

    ' Set the block of data to be written
    rc = mySql.cwbdbSetParameterMarkerBlock(rowsToSend, recordData.Bytes, _
                                            indicatorBuf(), sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      Close #fileNumber
      SendData = False
      Exit Function
    End If

    ' Execute the insert statement
    rc = mySql.cwbdbExecute("Insrt01", sysErr)
    If (rc <> cwbOK) Then
      ShowError ("SQL")
      SendData = False
      Close #fileNumber
      Exit Function
    End If
  Loop

  ' Close the input file
  Close #fileNumber

  SendData = True
End Function


'********************************************************************
'
'                          INITIALIZATION
'
'********************************************************************

Private Sub Form_Load()
  Dim rc As Long
  Dim as400Systems As New cwbx.SystemNames
  Dim systemName As Variant

  ' Initialize controls
  toDisplay.Value = True
  append.Value = True
  download.Default = True

  ' Populate the system names list using information from the SystemNames
  ' object
  For Each systemName In as400Systems
    systemList.AddItem systemName
  Next

  ' Set the current selection to the default system
  systemList.Text = UCase(as400Systems.DefaultSystem)

  ' Save the current selection
  currentSystem = systemList.Text

  ' Initialize the Client Access error object
  rc = sysErr.cwbsvSetup()
  If (rc <> cwbOK) Then
    ' This is not a critical error, so we will continue
    MsgBox "Error initializing the cwbErrorMessage object." & vbCr & _
           "return code = " & rc
  End If

  ' Set the conversion indicators to false, since we will use the
  ' Express conversion automation objects to handle the conversions
  myFormat.conversionIndicator = False
  myFormat.location = cwbdbSystem
  myParamFmt.conversionIndicator = False
  myParamFmt.location = cwbdbSystem

End Sub

'--------------------------------------------------------------------
Function StartServer() As Boolean

  ' If we do not already have a connection to the database server,
  ' create the database automation objects and start the server
  If (serverStarted = False) Then
    Set myDbConn = New cwbautsv.cwbDatabaseConnection
    Set mySql = New cwbautsv.cwbDatabaseSQL
    Set myCatalog = New cwbautsv.cwbDatabaseCatalog
    Set myDB2 = New cwbautsv.cwbDatabaseDB2

    ' Initialize the objects

    If (myDbConn.cwbdbSetup(currentSystem, sysErr) <> cwbOK) Then
      showCwbError
      StartServer = False
      Exit Function
    End If

    ' Initialize connection properties
    myDbConn.namingConvention = cwbdbPeriodNameConv
    myDbConn.dateFormat = cwbdbDateFmtISO
    myDbConn.convert65535 = True

    If (mySql.cwbdbSetup(myDbConn, myFormat, sysErr) <> cwbOK) Then
      ShowError ("SQL")
      StartServer = False
      Exit Function
    End If

    If (mySql.cwbdbSetSQLCA(mySQLCA, sysErr) <> cwbOK) Then
      ' This is not a critical error, so we will continue
      ShowError ("SQL")
    End If

    rc = myCatalog.cwbdbSetup(myDbConn, myFormat, sysErr)
    If (rc <> cwbOK) Then
      ShowError ("Catalog")
      StartServer = False
      Exit Function
    End If

    If (myDB2.cwbdbSetup(myDbConn, sysErr) <> cwbOK) Then
      ShowError ("DB2")
      StartServer = False
      Exit Function
    End If

    ' Start the server
    If (myDbConn.cwbdbStartServerDetailed(sysErr) <> cwbOK) Then
      showCwbError
      StartServer = False
      Exit Function
    End If
  End If

  StartServer = True
End Function


'********************************************************************
'
'                          ERROR HANDLING
'
'********************************************************************

Sub ShowError(requestType As String)
  Dim errClass As Integer
  Dim errCode As Long
  Dim msgID As String
  Dim msg1 As String
  Dim msg2 As String
  Dim msg3 As String

  ' Display any Client Access errors returned in the error object
  showCwbError

  ' Retrieve any host error information
  If (requestType = "SQL") Then
    mySql.cwbdbGetHostErrInfo errClass, errCode, msgID, msg1, msg2, sysErr

  ElseIf (requestType = "Catalog") Then
    myCatalog.cwbdbGetHostErrInfo errClass, errCode, msgID, msg1, msg2, sysErr

  ElseIf (requestType = "DB2") Then
    myDB2.cwbdbGetHostErrInfo errClass, errCode, msgID, msg1, msg2, sysErr
  End If

  ' Display the host error information
  If (errCode <> 0) Then
    MsgBox "Error class:  " & errClass & vbCr & _
           "Error code:  " & errCode & vbCr & _
           "Error message ID:  " & msgID & vbCr & vbCr & _
           "Message 1:  " & msg1 & vbCr & vbCr & _
           "Message 2:  " & msg2 & vbCr & vbCr & _
           "Message 3:  " & msg3
  End If

  ' For SQL requests, also display the contents of the SQLCA structure
  If (requestType = "SQL") Then
    showSQLCA
  End If
End Sub

'--------------------------------------------------------------------
Private Sub showCwbError()
  Dim errorText As String
  Dim errorCount As Long
  Dim currentError As Long
  Dim rc As Long

  ' Reset the mouse pointer
  Screen.MousePointer = vbDefault

  ' Retrieve the number of errors
  errorCount = sysErr.errorCount()

  ' Display a message box for each error returned
  For currentError = 1 To errorCount
    rc = sysErr.cwbsvGetErrTextIndexed(currentError, errorText)
    MsgBox errorText
  Next
End Sub

'--------------------------------------------------------------------
Private Sub showSQLCA()
  Dim messageText As String

  ' Retrieve the SQLCA error information
  mySql.cwbdbGetResultSQLCA sysErr

  ' If the SQL return code is non-zero, display the error information
  If (mySQLCA.sqlcode <> cwbOK) Then
    messageText = "SQL return code:  " & mySQLCA.sqlcode & vbCr & _
                  "Module:  " & mySQLCA.sqlerrp & vbCr & _
                  "Warning indicators:  " & mySQLCA.sqlwarn & vbCr & _
                  "Six digit SQLERRD:  " & mySQLCA.sqlerrd1 & "-" & _
                                          mySQLCA.sqlerrd2 & "-" & _
                                          mySQLCA.sqlerrd3 & "-" & _
                                          mySQLCA.sqlerrd4 & "-" & _
                                          mySQLCA.sqlerrd5 & "-" & _
                                          mySQLCA.sqlerrd6
    MsgBox messageText
  End If
End Sub


'********************************************************************
'
'                          MISCELLANEOUS
'
'********************************************************************

Private Sub systemList_LostFocus()

  ' Validate input value
  If (currentSystem = "") Then
    MsgBox "Enter a system name"
    systemList.SetFocus

  ' If the selection has changed
  ElseIf (systemList.Text <> currentSystem) Then
    ' Save the current selection
    currentSystem = systemList.Text

    ' If there was an active connection to the database server on the
    ' previous system, end the conversation
    If (serverStarted = True) Then
      serverStarted = False
      If (myDbConn.cwbdbStopServer(sysErr) <> cwbOK) Then
        showCwbError
      End If
    End If
  End If
End Sub

'--------------------------------------------------------------------
Private Sub closeBtn_Click()

  ' If there is an active connection to the database server, end it
  If (serverStarted = True) Then
    If (myDbConn.cwbdbStopServer(sysErr) <> cwbOK) Then
      showCwbError
    End If
  End If

  ' Close the program
  Unload Me
End Sub

'--------------------------------------------------------------------
Private Sub toDisplay_Click()
  downloadFile.Enabled = False
  downloadFileLabel.Enabled = False
End Sub

'--------------------------------------------------------------------
Private Sub toFile_Click()
  downloadFile.Enabled = True
  downloadFileLabel.Enabled = True
End Sub

'--------------------------------------------------------------------
Private Sub uploadFile_GotFocus()
  upload.Default = True
End Sub

'--------------------------------------------------------------------
Private Sub append_GotFocus()
  upload.Default = True
End Sub

'--------------------------------------------------------------------
Private Sub replace_GotFocus()
  upload.Default = True
End Sub

'--------------------------------------------------------------------
Private Sub toDisplay_GotFocus()
  download.Default = True
End Sub

'--------------------------------------------------------------------
Private Sub toFile_GotFocus()
  download.Default = True
End Sub

'--------------------------------------------------------------------
Private Sub downloadFile_GotFocus()
  download.Default = True
End Sub




